#include <stdio.h>
#include <stdlib.h>
//#include <conio.h>
#include <math.h>
#include <assert.h>

//#include <mydef.h>
#define _argc __argc
#define _argv __argv 

typedef unsigned int 	u_int;
typedef unsigned char 	u_char;

//********************************************************************
//********************************************************************
/*
dft file format:
	#for each Tpre double
	? ? ? - A koef
	? ? ? - B koef

*/
const double M_PI=3.14;

const double Fo=100.0;
const double Fd=44100.0;

u_int	 N=Fd/Fo;

//********************************************************************
void	usage()
{
	printf("Usage: dft {in MY_PCM file: Fd=%lf Hz,8bit,mono} {out dft file: Fo=%lf Hz}\n",Fd,Fo);
	exit(0);
}

//********************************************************************
//********************************************************************
void	dft_A(u_char *const buf,u_int const N, double *const out)
{
const u_int	M=N/2;
double		*p=out;

	{for(u_int m=1; m<M; m++)
	  {
	   double			Am=0;
	   char				*Ut=(char*)buf;

	   for(u_int n=0; n<N; n++, Ut++)Am+=(*Ut)*sin(2*M_PI*n*m/N);
	   Am*=2.0/N;

	   *p++=Am;
	  }}
}

//********************************************************************
//********************************************************************
void	dft_B(u_char *const buf,u_int const N, double *const out)
{
const u_int	M=N/2;
double		*p=out;

	{for(u_int m=1; m<M; m++)
	  {
	   double			Bm=0;
	   char				*Ut=(char*)buf;

	   for(u_int n=0; n<N; n++, Ut++)Bm+=(*Ut)*cos(2*M_PI*n*m/N);
	   Bm*=2.0/N;

	   *p++=Bm;
	  }}
}

//********************************************************************
//********************************************************************
void	dft_const(u_char *const buf,u_int const N, FILE *fo)
{
const u_int		M=N/2;
double			Uo=0;
char			*Ut=(char*)buf;

	for(u_int n=0; n<N; n++, Ut++)Uo+=*Ut;
	Uo/=N;

	assert(fwrite(&Uo,1,sizeof(double),fo)==sizeof(double));
}

//********************************************************************
void	read_params()
{
FILE	*fi=fopen("params.cfg","rb");
	assert(fi);
	assert(fscanf(fi,"%lf",&Fo));
	assert(fscanf(fi,"%lf",&Fd));

	N=Fd/Fo;

	fclose(fi);
}
//********************************************************************
//********************************************************************
void	main()
{
	read_params();
	if(_argc!=3)usage();

FILE	*fi=fopen(_argv[1],"rb"); assert(fi);
FILE	*fo=fopen(_argv[2],"wb"); assert(fo);

u_char  *buf=new char[N]; assert(buf);
double  *out=new double[N];

	fseek(fi,0,SEEK_END);
u_int const	fsize=ftell(fi);
	fseek(fi,0,SEEK_SET);

u_int			passed=0;
const u_int     total=fsize/N;

	printf("Fo=%lf Fd=%lf N=%u\n",Fo,Fd,N);
	printf("Total %u Tpre\n",total);
	while(1)
	 {
	  if(fread(buf,1,N,fi)!=N)break;

	  dft_const(buf,N,fo);

	  dft_A(buf,N,out);
	  assert(fwrite(out,1,sizeof(double)*(N/2),fo)==sizeof(double)*(N/2));

	  dft_B(buf,N,out);
	  assert(fwrite(out,1,sizeof(double)*(N/2),fo)==sizeof(double)*(N/2));

	  printf("\r%u passed", ++passed );
	  fflush(stdout);
	 }
    printf("\n");

	delete[] out;
	delete[] buf;

	fclose(fi);
	fclose(fo);
}
//********************************************************************
