#include <stdio.h>
#include <stdlib.h>
//#include <conio.h>
#include <math.h>
#include <assert.h>

//#include <mydef.h>
#define _argc __argc
#define _argv __argv 

typedef unsigned int 	u_int;
typedef unsigned char 	u_char;

//********************************************************************
//********************************************************************
/*
dft file format:
	#for each Tpre double
	? ? ? - A koef
	? ? ? - B koef

*/
const double M_PI=3.14;

const double Fo=100.0;
const double Fd=44100.0;

u_int	 N=Fd/Fo;

//********************************************************************
void	usage()
{
	printf("Usage: idft {in dft file: Fo=%lf Hz} {out MY_PCM file: Fd=%.0lf Hz,8bit,mono} \n",Fo,Fd);
	exit(0);
}

//********************************************************************
//********************************************************************
void	idft( double *const buf, u_int const N, u_char *const out )
{
const u_int		M=N/2;
u_char			*p=out;

	{for(u_int n=0; n<N; n++)
	 {
	  double	Ut=0;
	  double	*Am=buf+1,*Bm=buf+M+1;
	  double	Uo=*buf;

	  for(u_int m=1; m<M; m++)
	   {
		Ut+=(*Am++)*sin(2*M_PI*n*m/N);
		Ut+=(*Bm++)*cos(2*M_PI*n*m/N);
		//printf("%lf%lf%lf\n",Ut,Uo,Ut+Uo);
	   }

	  //Ut=64*sin(2*M_PI*n/N);
	  Ut+=Uo;
	  *p++=Ut;
	 }}
}

//********************************************************************
void	read_params()
{
FILE	*fi=fopen("params.cfg","rb");
	assert(fi);
	assert(fscanf(fi,"%lf",&Fo));
	assert(fscanf(fi,"%lf",&Fd));

	N=Fd/Fo;

	fclose(fi);
}

//********************************************************************
//********************************************************************
void	main()
{
	read_params();
	if(_argc!=3)usage();

FILE	*fi=fopen(_argv[1],"rb"); assert(fi);
FILE	*fo=fopen(_argv[2],"wb"); assert(fo);

double  *buf=new double[N+1];
u_char  *out=new char[N];

	fseek(fi,0,SEEK_END);
u_int const	fsize=ftell(fi);
	fseek(fi,0,SEEK_SET);

u_int			passed=0;
const u_int     total=fsize/((N+1)*sizeof(double));

	printf("Fo=%lf Fd=%lf N=%u\n",Fo,Fd,N);
	printf("Total %u Tpre\n",total);
	while(1)
	 {
	  if(fread(buf,1,sizeof(double)*(N+1),fi)!=sizeof(double)*(N+1))break;
	  idft(buf,N,out);
	  assert(fwrite(out,1,N,fo)==N);

	  printf("\r%u passed",++passed);
	  fflush(stdout);
	 }
	printf("\n");

	delete[] out;
	delete[] buf;

	fclose(fi);
	fclose(fo);
}
//********************************************************************
