#include <stdio.h>
#include <stdlib.h>
#include <graph.h>
#include <conio.h>
#include <math.h>
#include <assert.h>

//#include <mydef.h>
#define _argc __argc
#define _argv __argv 

typedef unsigned int 	u_int;
typedef unsigned char 	u_char;

//********************************************************************
//********************************************************************
/*
dft file format:
	#for each Tpre double
	? ? ? - A koef
	? ? ? - B koef

*/
const double M_PI=3.14;

const double Fo=100.0;
const double Fd=44100.0;

u_int	N=Fd/Fo;

//********************************************************************
void	usage()
{
	printf("Usage: v {dft file for view : Fo=%lf Hz}\n",Fo);
	exit(0);
}
//********************************************************************
//********************************************************************
void	view( double *const buf, u_int const N, const u_int pass, const u_int total )
{
const u_int x=10;
const u_int y=10;

const u_int LX=500;
const u_int LY=400;

const u_int A_scale=LY/(2*100);

const u_int		M=N/2;
const u_int		step_x=LX/M;

double			*Am=buf+1,*Bm=buf+M+1;
	//Am
	_clearscreen(_GCLEARSCREEN);
	_setcolor(1);
	_moveto(x,y);
	_lineto(x,y+LY);
	_moveto(x,y+LY/2);
	_lineto(x+LX,y+LY/2);

	printf("Pass %u (total %u)\n",pass,total);
	printf("Am view: (Uo=%lf)\n",*buf);
	_setcolor(2);
	{for( u_int m=1; m<M; m++ )
	 {
	  _moveto(x+m*step_x,y+LY/2);
	  _lineto(x+m*step_x,y+LY/2-A_scale*(*Am));
	  ++Am;
	 }}
	getch();

	//Bm
	_clearscreen(_GCLEARSCREEN);
	_setcolor(1);
	_moveto(x,y);
	_lineto(x,y+LY);
	_moveto(x,y+LY/2);
	_lineto(x+LX,y+LY/2);

	printf("Pass %u (total %u)\n",pass,total);
	printf("Bm view: (Uo=%lf)\n",*buf);

	_setcolor(3);
	{for( u_int m=1; m<M; m++ )
	 {
	  _moveto(x+m*step_x,y+LY/2);
	  _lineto(x+m*step_x,y+LY/2-A_scale*(*Bm));
	  ++Bm;
	 }}
	getch();
}

//********************************************************************
void	read_params()
{
FILE	*fi=fopen("params.cfg","rb");
	assert(fi);
	assert(fscanf(fi,"%lf",&Fo));
	assert(fscanf(fi,"%lf",&Fd));

	N=Fd/Fo;

	fclose(fi);
}
//********************************************************************
//********************************************************************
void	main()
{
	read_params();
	if(_argc!=2)usage();

FILE	*fi=fopen(_argv[1],"rb"); assert(fi);

	_setvideomode(_VRES16COLOR);

double  *buf=new double[N+1];

	fseek(fi,0,SEEK_END);
const u_int	fsize=ftell(fi);
	fseek(fi,0,SEEK_SET);

u_int			passed=0;
const u_int     total=fsize/((N+1)*sizeof(double));

	while(1)
	 {
	  if(fread(buf,1,sizeof(double)*(1+N),fi)!=sizeof(double)*(1+N))break;
	  view(buf,N,++passed,total);
	 }

	delete[] buf;

	_setvideomode(_DEFAULTMODE);
	fclose(fi);
}
//********************************************************************
